/*******************************************************************************
* $Id: priv.h,v 1.28 2002/12/18 15:45:56 attolcov Exp $
* $Descr: I/O and Systems routines header (included by TP.h) $
*******************************************************************************/
/* Multiple inclusions guard: */
#ifndef PRIV_H_INCLUDED
#define PRIV_H_INCLUDED

#if defined(RTRT_TDP_COMPILATION) || \
  (USE_ATS && \
   !defined(ATL_CPLUSPLUS_INSTRUMENTOR) && \
   !defined(ATL_C_INSTRUMENTOR))

#if USE_ATS
/*! Needs priv_flush() */
#define NEEDS_priv_flush()
#endif

#if USE_ATS
/*! Needs priv_rdv() */
#define NEEDS_priv_rdv
#endif

#if USE_ATS
/*! Needs priv_sleep() */
#define NEEDS_priv_sleep
#endif

#if USE_ATK
#define NEEDS_MT_REC_MUTEX
#endif

#if USE_ATS || defined(NEEDS_MT_REC_MUTEX)
/*! Needs priv_malloc() */
#define NEEDS_priv_malloc
#endif

#if USE_ATS || defined(NEEDS_MT_REC_MUTEX)
/*! Needs priv_free() */
#define NEEDS_priv_free
#endif

#if USE_ATS
/*! Needs priv_realloc */
#define NEEDS_priv_realloc
#endif

#if USE_ATS
/*! Needs priv_*_tagtlk() */
#define NEEDS_tagtlk
#endif

#if USE_ATS
/*! Needs priv_memcpy() */
#define NEEDS_priv_memcpy
#endif

#if !USE_ATU && !USE_ATS && !USE_ATO
/*! Needs priv_getpid() */
#define NEEDS_priv_getpid
#endif

#if RTRT_IO == RTRT_STD
#include <stdio.h>
#include <stdlib.h>
/*! Type handled by I/O routines */
#define RTRT_FILE_TYPE FILE *
#elif RTRT_IO == RTRT_NONE
#define RTRT_FILE_TYPE int
#endif /* RTRT_IO */

_ATL_EXTERN_C RTRT_FILE_TYPE priv_open
#if !RTRT_KR
  (char *)
#else
  ()
#endif
  ;

_ATL_EXTERN_C RTRT_FILE_TYPE priv_init
#if !RTRT_KR
  (char * name)
#else
  ()
#endif
  ;

_ATL_EXTERN_C void priv_close
#if !RTRT_KR
  (RTRT_FILE_TYPE file)
#else
  ()
#endif
  ;

#ifdef NEEDS_priv_flush
_ATL_EXTERN_C void priv_flush
#if !RTRT_KR
  (RTRT_FILE_TYPE file)
#else
  ()
#endif
  ;
#endif /* NEEDS_priv_flush */

_ATL_EXTERN_C void priv_writeln
#if !RTRT_KR
  (RTRT_FILE_TYPE, char *)
#else
  ()
#endif
  ;

_ATL_EXTERN_C void priv_check_failed
#if !RTRT_KR
  ()
#else
  (void)
#endif
  ;

_ATL_EXTERN_C int priv_rdv
#if !RTRT_KR
  (char *)
#else
  ()
#endif
  ;

#ifdef NEEDS_tagtlk

#if RTRT_DYNAMIC_TRACKING
/*! Type used for communications between Virtual Testers and Agent */
#define ATL_TSTAGT_COMMTYPE int
#endif /* RTRT_DYNAMIC_TRACKING */

_ATL_EXTERN_C int priv_boot_tagtlk
#if !RTRT_KR
  (ATL_TSTAGT_COMMTYPE *, char *, char *, int *, int *)
#else
  ()
#endif
  ;

_ATL_EXTERN_C void priv_close_tagtlk
#if !RTRT_KR
  (ATL_TSTAGT_COMMTYPE *)
#else
  ()
#endif
  ;

_ATL_EXTERN_C int priv_raiseline_tagtlk
#if !RTRT_KR
  (ATL_TSTAGT_COMMTYPE *, char *)
#else
  ()
#endif
  ;

_ATL_EXTERN_C int priv_interrecv
#if !RTRT_KR
  (ATL_TSTAGT_COMMTYPE *, int, char *, int, char **, char **)
#else
  ()
#endif
  ;

_ATL_EXTERN_C int priv_send_chk
#if !RTRT_KR
  (ATL_TSTAGT_COMMTYPE *, char *)
#else
  ()
#endif
  ;

#endif /* NEEDS_tagtlk */

#ifdef NEEDS_priv_sleep
_ATL_EXTERN_C void priv_sleep
#if !RTRT_KR
  (RTRT_TIME_TYPE)
#else
  ()
#endif
  ;
#endif

#ifdef NEEDS_priv_malloc
_ATL_EXTERN_C void *priv_malloc
#if !RTRT_KR
  (RTRT_SIZE_T size)
#else
  (size)
  RTRT_SIZE_T size;
#endif
  ;
#endif

#ifdef NEEDS_priv_realloc
_ATL_EXTERN_C void *priv_realloc
#if !RTRT_KR
  (void *p,
   RTRT_SIZE_T new_size)
#else
  (p, new_size)
  RTRT_SIZE_T size;
#endif
  ;
#endif

#ifdef NEEDS_priv_free
_ATL_EXTERN_C void priv_free
#if !RTRT_KR
  (void *p)
#else
  ()
#endif
  ;
#endif

_ATL_EXTERN_C void priv_exit
#if !RTRT_KR
  (RTRT_INT32 ec)
#else
  ()
#endif
  ;

#ifdef NEEDS_priv_memcpy
_ATL_EXTERN_C void *priv_memcpy
#if !RTRT_KR
  (void *, void *, unsigned int)
#else
  ()
#endif
  ;
#endif

#endif /* RTRT_TDP_COMPILATION ... */

#endif
